package com.sun.xml.tree;

import java.io.IOException;
import java.io.Writer;
import org.w3c.dom.DOMException;
import org.w3c.dom.EntityReference;
import org.w3c.dom.Node;

final class XmlDocument$EntityRefNode extends ParentNode implements EntityReference {
   private String entity;

   XmlDocument$EntityRefNode(String var1) {
      if (var1 == null) {
         throw new IllegalArgumentException(((NodeBase)this).getMessage("XD-002"));
      } else {
         this.entity = var1;
      }
   }

   void checkChildType(int var1) throws DOMException {
      switch (var1) {
         case 1:
         case 3:
         case 4:
         case 5:
         case 7:
         case 8:
            return;
         case 2:
         case 6:
         default:
            throw new DomEx((short)3);
      }
   }

   public Node cloneNode(boolean var1) {
      XmlDocument$EntityRefNode var2 = new XmlDocument$EntityRefNode(this.entity);
      ((NodeBase)var2).setOwnerDocument((XmlDocument)((NodeBase)this).getOwnerDocument());
      Node var3;
      if (var1) {
         for(int var4 = 0; (var3 = ((ParentNode)this).item(var4)) != null; ++var4) {
            var3 = var3.cloneNode(true);
            ((ParentNode)var2).appendChild(var3);
         }
      }

      return var2;
   }

   public String getNodeName() {
      return this.entity;
   }

   public short getNodeType() {
      return 5;
   }

   public void writeXml(XmlWriteContext var1) throws IOException {
      if (!var1.isEntityDeclared(this.entity)) {
         throw new IOException(((NodeBase)this).getMessage("XD-003", new Object[]{this.entity}));
      } else {
         Writer var2 = var1.getWriter();
         var2.write(38);
         var2.write(this.entity);
         var2.write(59);
      }
   }
}
